
%define module1_name cups-pantum
%define module1_version 1.1.106
%define module2_name libsane-pantum
%define module2_version 1.1.106
%define module3_name cups-pantum-ipp
%define module3_version 1.1.106

%define module_builddir $RPM_BUILD_DIR/%{module2_name}-%{version}-%{release}


Name: %{module2_name}
Version: %{module2_version}
Release: 1%{?dist}
Summary: libsane drivers for Pantum printers (inkl. P2502W)
#Group: Application/Printing
License: commercial
URL: https://global.pantum.com/support/download/driver/
Source0: pantum_1.1.106-1_amd64.deb
# 2023-10-30 for P2502W: https://global.pantum.com/download/getFileLink?menuId=1517378576861671426&dataId=1549571939642736641

AutoReq: no
Requires: sane-backends, libjpeg-turbo
# XXX the following is a list of autoreq-dependencies, minus the bad apple libjpeg.so.8, while doesnt exist in fedora, but is being provided for by libjpeg-turbo.so.*
Requires: libc.so.6()(64bit), libc.so.6(GLIBC_2.14)(64bit), libc.so.6(GLIBC_2.15)(64bit), libc.so.6(GLIBC_2.2.5)(64bit), libc.so.6(GLIBC_2.3)(64bit), libc.so.6(GLIBC_2.3.4)(64bit), libc.so.6(GLIBC_2.4)(64bit), libc.so.6(GLIBC_2.7)(64bit), libm.so.6()(64bit), libm.so.6(GLIBC_2.2.5)(64bit), libpthread.so.0()(64bit), libpthread.so.0(GLIBC_2.2.5)(64bit), libusb-1.0.so.0()(64bit), rpmlib(CompressedFileNames) <= 3.0.4-1, rpmlib(FileDigests) <= 4.6.0-1, rpmlib(PayloadFilesHavePrefix) <= 4.0-1, rpmlib(PayloadIsZstd) <= 5.4.18-1, rtld(GNU_HASH)

BuildArch: x86_64
BuildRequires: alien

%description
This package provides the SANE drivers for Pantum printers (P2502W and probably others, too).





%prep
rm -rf %{module_builddir} ||:
mkdir -p %{module_builddir}/%{module1_name}-%{version}
cd %{module_builddir}/%{module1_name}-%{version}
alien -g %{SOURCE0}
mv %{module_builddir}/%{module1_name}-%{module1_version}/pantum-%{module1_version}/{etc,opt,usr}/ %{module_builddir}/
#rm -rf %{module_builddir}/%{module1_name}-%{module1_version}/pantum-%{module1_version}/
#rm -rf %{module_builddir}/%{module1_name}-%{module1_version}/pantum-%{module1_version}.orig/
rm -rf %{module_builddir}/%{module1_name}-%{module1_version}/

# XXX the things we do for lo... i mean, hardware manufacturers that give out driver binaries instead of the source to allow us recompiling with libjpeg-turbo instead of the used libjpeg.so.8 from the stoneages.
if [ ! -e "/usr/lib64/libjpeg.so.8" ] && [ -e "/usr/lib64/libjpeg.so.62" ]; then
  ln -sf libjpeg.so.62 /usr/lib64/libjpeg.so.8 ||:
fi

# module2-specific
sed -i 's#ExecStart=/opt/pantum/bin/#/usr/sbin/#g' %{module_builddir}/opt/pantum/ippfilter/*.service


%install
# module 2
mkdir -p $RPM_BUILD_ROOT/etc/sane.d/dll.d/
mkdir -p $RPM_BUILD_ROOT/usr/lib/sane/
mkdir -p $RPM_BUILD_ROOT/usr/lib64/
mkdir -p $RPM_BUILD_ROOT/usr/share/doc/%{module2_name}/
mkdir -p $RPM_BUILD_ROOT/usr/share/licenses/%{module2_name}/
install %{module_builddir}/usr/local/etc/sane.d/*.conf $RPM_BUILD_ROOT/etc/sane.d/
install %{module_builddir}/usr/local/etc/sane.d/dll.d/* $RPM_BUILD_ROOT/etc/sane.d/dll.d/
install %{module_builddir}/usr/local/lib/sane/*.so.1.* $RPM_BUILD_ROOT/usr/lib/sane/
for fn in $RPM_BUILD_ROOT/usr/lib/sane/*; do
  fndest="${fn##*/}"
  fn1="${fn%.*}"
  fn2="${fn1%.*}"
  if [ "x$fndest" != "x" ] && [ "x$fn1" != "x" ] && [ "x$fn2" != "x" ]; then
    ln -s $fndest $fn1
    ln -s $fndest $fn2
  fi
done
## XXX same files as in /usr/lib/sane/, so no need: install %{module_builddir}/usr/lib/x86_64-linux-gnu/sane/* $RPM_BUILD_ROOT/usr/lib/x86_64-linux-gnu/sane/
install %{module_builddir}/usr/share/doc/pantum/* $RPM_BUILD_ROOT/usr/share/doc/%{module2_name}/
install %{module_builddir}/usr/share/doc/pantum/copyright $RPM_BUILD_ROOT/usr/share/licenses/%{module2_name}/LICENSE


%pre
# XXX the things we do for lo... i mean, hardware manufacturers that give out driver binaries instead of the source to allow us recompiling with libjpeg-turbo instead of the used libjpeg.so.8 from the stoneages.
if [ ! -e "/usr/lib64/libjpeg.so.8" ] && [ -e "/usr/lib64/libjpeg.so.62" ]; then
  ln -sf libjpeg.so.62 /usr/lib64/libjpeg.so.8 ||:
fi

#% preun
## XXX yeah, this can go wrong, if someone actually install libjpeg.so.8.. which is highly unlikely since it old and unmaintained. but if this case rears its ugly head, someone will have a missing "major version" link for their libjpeg.so.8.x.x
##     since two packages by pantum company need the libjpeg.so.8 from the stoneages, we cant ever delete it ourselves.
#if [ -e "/usr/lib64/libjpeg.so.8" ] && [ -h "/usr/lib64/libjpeg.so.8" ]; then
#  rm -f /usr/lib64/libjpeg.so.8
#fi

%post
/sbin/ldconfig ||:

%postun
/sbin/ldconfig ||:



%files
%doc /usr/share/doc/%{module2_name}/copyright
%doc /usr/share/doc/%{module2_name}/changelog.gz
/etc/sane.d/*.conf
/etc/sane.d/dll.d/pantum*
/usr/lib/sane/*
%license /usr/share/licenses/%{module2_name}/LICENSE


%changelog
* Mon Oct 30 2023 Frederic Krueger <fkrueger-dev-cupspantum@holics.at> 1.1.106-1
- Initial spec file created based on the deb package by Pantum themselves

